#include <msp/gl/renderer.h>
#include "catalogue.h"
#include "layout.h"
#include "signal.h"
#include "signaltype.h"

using namespace Msp;

namespace R2C2 {

Signal3D::Signal3D(Layout3D &l, Signal &s):
	Object3D(l, s),
	GL::ObjectInstance(l.get_catalogue().get_3d(s.get_type()).get_object()),
	signal(s)
{
	layout.get_scene().add(*this);
}

Signal3D::~Signal3D()
{
	layout.get_scene().remove(*this);
}

Vector Signal3D::get_node() const
{
	return matrix*Vector(0, -0.035, 0.13);
}

void Signal3D::setup_render(GL::Renderer &renderer, const GL::Tag &) const
{
	renderer.matrix_stack() *= matrix;
	// XXX Use track gauge, configure signal side
	renderer.matrix_stack() *= GL::Matrix::translation(0, -0.035, 0);
}

} // namespace R2C2
