#ifndef LIBR2C2_AICONTROL_H_
#define LIBR2C2_AICONTROL_H_

#include <sigc++/trackable.h>
#include "trainai.h"

namespace R2C2 {

class Train;

class AIControl: public TrainAI, public sigc::trackable
{
private:
	enum State
	{
		NORMAL,
		APPROACH,
		BLOCKED,
		FOLLOW
	};

	float target_speed;
	bool reverse;
	bool pending_reverse;
	State state;
	bool need_update;

public:
	AIControl(Train &);

	void set_target_speed(float);
	float get_target_speed() const { return target_speed; }
	void set_reverse(bool);
	bool get_reverse() const { return reverse; } 

	virtual void message(const Message &);
	virtual void tick(const Msp::Time::TimeDelta &);
	virtual bool has_intent_to_move() const;

private:
	void event(TrainAI &, const Message &);
};

} // namespace R2C2

#endif
