#ifndef LIBR2C2_SIMPLECONTROLLER_H_
#define LIBR2C2_SIMPLECONTROLLER_H_

#include <string>
#include "controller.h"

namespace R2C2 {

class SimpleController: public Controller
{
private:
	Control target_speed;
	Control reverse;
	float accel;
	float speed;

public:
	SimpleController();

	virtual const char *enumerate_controls(unsigned) const;
	virtual void set_control(const std::string &, float);
	virtual const Control &get_control(const std::string &) const;

	virtual float get_speed() const { return speed; }
	virtual bool get_reverse() const { return reverse.value; }
	virtual float get_braking_distance() const;

	virtual void tick(const Msp::Time::TimeDelta &);
};

} // namespace R2C2

#endif
