#ifndef LIBR2C2_SPEEDQUANTIZER_H_
#define LIBR2C2_SPEEDQUANTIZER_H_

#include <list>
#include <vector>
#include <msp/datafile/objectloader.h>

namespace R2C2 {

class SpeedQuantizer
{
public:
	class Loader: public Msp::DataFile::ObjectLoader<SpeedQuantizer>
	{
	public:
		Loader(SpeedQuantizer &);
	private:
		void step(unsigned, float, float);
	};

private:
	struct SpeedStep
	{
		float speed;
		float weight;

		SpeedStep();
		void add(float, float);
	};

	std::vector<SpeedStep> steps;
	float weight_limit;

public:
	SpeedQuantizer(unsigned);

	void learn(unsigned, float, float);
	float get_speed(unsigned) const;
	float quantize_speed(float) const;
	unsigned find_speed_step(float) const;

	void save(std::list<Msp::DataFile::Statement> &) const;
};

} // namespace R2C2

#endif
